package cn.com.ctop.okr.feishu.provider;

import cn.com.ctop.okr.feishu.constant.FeishuConstant;
import cn.com.ctop.okr.utils.HttpUtils;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang.StringUtils;

import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

public class DepartmentProvider {

    /**
     * 获取子部门列表（遍历获取所有部门）
     * @param page_token
     * @return
     * @throws Exception
     */
    public static JSONObject getDepartSimpleList(String department_id, String page_token) throws Exception {
        Map<String,String> headers = new HashMap<>();
        TreeMap<String,Object> params = new TreeMap<>();
        headers.put("Authorization","Bearer "+ AuthProvider.getAppAccessToken());
        params.put("department_id", department_id);
        if(StringUtils.isNotBlank(page_token)){
            params.put("page_token",page_token);
        }
        params.put("page_size",100);
        params.put("fetch_child",true);

        String resultStr = HttpUtils.httpGetRequest(FeishuConstant.FEISHU_API_URL+FeishuConstant.DEPARTMENT_SIMPLE_LIST,headers,params);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        System.out.println(resultJson);

        //Boolean hasMore = resultJson.getJSONObject("data").getBoolean("has_more");
        //if(hasMore == true){
        //    String pageToken = resultJson.getString("page_token");
        //    getDepartSimpleList(department_id, pageToken);
        //}
        return resultJson;
    }

    /**
     * 根据部门获取部门下所有员工详细信息
     * @param department_id
     * @param page_token
     * @throws Exception
     */
    public static JSONObject getDepartmentUserDetailList(String department_id, String page_token) throws Exception {
        Map<String,String> headers = new HashMap<>();
        TreeMap<String,Object> params = new TreeMap<>();
        headers.put("Authorization","Bearer "+ AuthProvider.getAppAccessToken());
        params.put("department_id", department_id);
        if(StringUtils.isNotBlank(page_token)){
            params.put("page_token",page_token);
        }
        params.put("page_size",100);
        params.put("fetch_child",true);

        String resultStr = HttpUtils.httpGetRequest(FeishuConstant.FEISHU_API_URL+FeishuConstant.DEPARTMENT_USER_DETAIL_LIST,headers,params);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        System.out.println(resultJson);

        //Boolean hasMore = resultJson.getJSONObject("data").getBoolean("has_more");
        //if(hasMore == true){
        //    String pageToken = resultJson.getString("page_token");
        //    getDepartmentUserDetailList(department_id, pageToken);
        //}
        return resultJson;
    }



    public static void main(String[] args) throws Exception {
        //getDepartSimpleList("0",null);
        getDepartmentUserDetailList("od-ed707e2994b4251d5edc20bb35f0ced9", null);
    }




















}
